library linuxwindowapache;

{$ifdef fpc}
 {$mode objfpc}{$H+}
{$endif}

{$IFDEF WIN32}
  {$DEFINE WINDOWS}
{$ENDIF}

{$define Apache2_0}
{$define apachemodule}

uses SysUtils, httpd, apr, apacheadapter, main, Classes;

{ Note:
 These configrations are used by apache2.conf or httpd.conf file.
 Make sure to confgure it properly in every new Add FreeSpider Apache Module Project
}

const

       MODULE_NAME = 'mod_lw.so';
       MODNAME = 'apache_lw';
       HANDLER_NAME = 'lw-handler';

{
 This is the configuration in apache2.conf file for above settings in Linux:

LoadModule apache_lw /usr/lib/apache2/modules/mod_lw.so

<Location /lw>
     SetHandler lw-handler
</Location>

and this is Windows configuration version of the same exmaple:

LoadModule apache_starter c:\projects\ApacheStarter\mod_lw.dll

<Location /lw>
     SetHandler lw-handler
</Location>

Example of accessing this module from browser: 
   http://localhost/lw
}




var
   current_module: module; {$ifdef Unix} public name modName; {$endif}
   default_module_ptr: Pmodule;



exports
   current_module name ModName;

function DefaultHandler(r: Prequest_rec): Integer; cdecl;
begin
   Result:= ProcessHandler(r, TDataModule1, MODULE_NAME, HANDLER_NAME);
end;


procedure RegisterHooks(p: Papr_pool_t); cdecl;
begin
   ap_hook_handler(@DefaultHandler, nil, nil, APR_HOOK_MIDDLE);
end;

begin

  default_module_ptr := @current_module;
  FillChar(default_module_ptr^, SizeOf(default_module_ptr^), 0);

  STANDARD20_MODULE_STUFF(current_module);

  with current_module do
  begin
     name := MODULE_NAME;
     register_hooks := @RegisterHooks;
  end;
end.
